Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/programming/CreateFnFunction.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/programming/CreateFnFunction.java	(revision 44532)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/programming/CreateFnFunction.java	(revision 44533)
@@ -1,9 +1,12 @@
 package org.gvsig.expressionevaluator.impl.function.programming;
 
+import java.lang.reflect.Method;
 import java.util.ArrayList;
 import java.util.Arrays;
 import java.util.List;
+import java.util.Objects;
 import org.apache.commons.lang3.Range;
+import org.apache.commons.lang3.StringUtils;
 import org.gvsig.expressionevaluator.Code;
 import org.gvsig.expressionevaluator.Codes;
 import org.gvsig.expressionevaluator.Function;
@@ -14,6 +17,10 @@
 import org.gvsig.expressionevaluator.ExpressionRuntimeException;
 import org.gvsig.expressionevaluator.MutableSymbolTable;
 import org.gvsig.expressionevaluator.SymbolTable;
+import org.gvsig.tools.ToolsLocator;
+import org.gvsig.tools.resourcesstorage.ResourcesStorage;
+import org.gvsig.tools.script.Script;
+import org.gvsig.tools.script.ScriptManager;
 
 public class CreateFnFunction extends AbstractFunction {
     
@@ -22,7 +29,7 @@
     public CreateFnFunction() {
         super(Function.GROUP_PROGRAMMING, 
                 NAME, 
-                Range.between(2, 3),
+                Range.between(2, 6),
                 null,
                 null,
                 null,
@@ -56,7 +63,10 @@
         
         String name;
         List<String> argNames;
-        Code body;
+        Code body = null;
+        String script_path = null;
+        String script_function = null;
+        String language = null;
         switch(args.size()) {
             case 2:
                 name = (String) getObject(interpreter, args, 0);
@@ -72,13 +82,44 @@
                 }
                 body = args.get(2);
                 break;
+            case 6:
+                name = (String) getObject(interpreter, args, 0);
+                if( args.get(1)==null ) {
+                    argNames = null;
+                } else {
+                    argNames = (List<String>) getObject(interpreter, args, 1);
+                }
+                body = args.get(2);
+                script_path = Objects.toString(args.get(2),null);
+                script_function = Objects.toString(args.get(3),null);
+                language = Objects.toString(args.get(4),null);
+                break;
             default:
                 throw new ExpressionRuntimeException("Incorrect number of arguments");
         }
-        
-        Function fn = new UserFunction(name, argNames, body);
-        symbolTable.addFunction(fn);
-        return fn;
+        Function fn;
+        if( body!=null ) {
+            fn = new UserFunction(name, argNames, body);
+            symbolTable.addFunction(fn);
+            return fn;
+        }
+        if( StringUtils.isBlank(script_path) || StringUtils.isBlank(script_function) ) {
+            throw new ExpressionRuntimeException("boydy and, script path or script function, are empty.");
+        }
+        if( StringUtils.isBlank(language) ) {
+            language = "script";
+        }
+        switch(language.toLowerCase()) {
+            case "script":
+                fn = new ExternalFunction(name, script_path, script_function);
+                symbolTable.addFunction(fn);
+                return fn;
+            case "java":
+                fn = new JavaFunction(name, script_path, script_function);
+                symbolTable.addFunction(fn);
+                return fn;
+        }
+        throw new ExpressionRuntimeException("Unsupported language '"+language+".");
     }
     
     private static class UserFunction extends AbstractFunction {
@@ -126,4 +167,59 @@
         
     }
     
+    private static class ExternalFunction extends AbstractFunction {
+
+        private final String script_path;
+        private final String script_function;
+
+        public ExternalFunction(String name, String script_path, String script_function) {
+            super(GROUP_OTHER, name, Range.between(0, Integer.MAX_VALUE));
+            this.script_path = script_path;
+            this.script_function = script_function;
+        }
+        
+        @Override
+        public Object call(Interpreter interpreter, Object[] args) throws Exception {
+            ScriptManager scriptManager = ToolsLocator.getScriptManager();
+            ExpressionEvaluatorManager expressionManager = ExpressionEvaluatorLocator.getExpressionEvaluatorManager();
+            ResourcesStorage resourcesStorage = expressionManager.getScriptsResourcesStorage();
+            Script sc = scriptManager.loadScript(resourcesStorage, script_path);
+            if( sc == null ) {
+                throw new ExpressionRuntimeException("Can't locate '"+this.script_path+"'.");
+            }
+            Object r = sc.invokeFunction(this.script_function, args);
+            return r;
+        }
+        
+    }
+
+    private static class JavaFunction extends AbstractFunction {
+
+        private final String fullClassName;
+        private final String methodName;
+
+        public JavaFunction(String name, String fullClassName, String methodName) {
+            super(GROUP_OTHER, name, Range.between(0, Integer.MAX_VALUE));
+            this.fullClassName = fullClassName;
+            this.methodName = methodName;
+        }
+        
+        @Override
+        public Object call(Interpreter interpreter, Object[] args) throws Exception {
+            Class[] parameterTypes = new Class[args.length];
+            for (int i = 0; i < args.length; i++) {
+                if( args[i]==null ) {
+                    parameterTypes[i] = null;
+                } else {
+                    parameterTypes[i] = args[i].getClass();
+                }
+            }
+            Class<?> theClass = Class.forName(this.fullClassName);
+            Method method = theClass.getMethod(this.methodName, parameterTypes);
+            Object value = method.invoke(null, args);
+            return value;
+        }
+        
+    }
+
 }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.swing/org.gvsig.expressionevaluator.swing.api/src/main/java/org/gvsig/expressionevaluator/swing/JExpressionBuilder.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.swing/org.gvsig.expressionevaluator.swing.api/src/main/java/org/gvsig/expressionevaluator/swing/JExpressionBuilder.java	(revision 44532)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.swing/org.gvsig.expressionevaluator.swing.api/src/main/java/org/gvsig/expressionevaluator/swing/JExpressionBuilder.java	(revision 44533)
@@ -9,6 +9,8 @@
  */
 public interface JExpressionBuilder extends Component, ExpressionBuilderConfig {
 
+    public static final String CONFIGURABLE_PANEL_ID = "JExpressionBuilder";
+    
     public Expression getExpressionWithOutHistory();
 
     public Expression getExpression();
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.swing/org.gvsig.expressionevaluator.swing.api/src/main/java/org/gvsig/expressionevaluator/swing/ExpressionBuilderConfig.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.swing/org.gvsig.expressionevaluator.swing.api/src/main/java/org/gvsig/expressionevaluator/swing/ExpressionBuilderConfig.java	(revision 44532)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.swing/org.gvsig.expressionevaluator.swing.api/src/main/java/org/gvsig/expressionevaluator/swing/ExpressionBuilderConfig.java	(revision 44533)
@@ -26,10 +26,10 @@
          */
         public void setSimpleElementsLimit(int limit);
 
-        public void setScriptsEnabled(boolean enabled);
+//        public void setScriptsEnabled(boolean enabled);
+//
+//        public boolean getScriptsEnabled();
 
-        public boolean getScriptsEnabled();
-
         public void setSQLCompatible(boolean sqlCompatible);
 
         public boolean isSQLCompatible();
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.swing/org.gvsig.expressionevaluator.swing.impl/src/main/java/org/gvsig/expressionevaluator/swing/impl/DefaultExpressionBuilderConfig.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.swing/org.gvsig.expressionevaluator.swing.impl/src/main/java/org/gvsig/expressionevaluator/swing/impl/DefaultExpressionBuilderConfig.java	(revision 44532)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.swing/org.gvsig.expressionevaluator.swing.impl/src/main/java/org/gvsig/expressionevaluator/swing/impl/DefaultExpressionBuilderConfig.java	(revision 44533)
@@ -134,17 +134,17 @@
         this.symbolTables.remove(name);
     }
 
+//    @Override
+//    public void setScriptsEnabled(boolean enabled) {
+//        this.scriptsEnabled = enabled;
+//    }
+//
+//    @Override
+//    public boolean getScriptsEnabled() {
+//        return this.scriptsEnabled;
+//    }
+//
     @Override
-    public void setScriptsEnabled(boolean enabled) {
-        this.scriptsEnabled = enabled;
-    }
-
-    @Override
-    public boolean getScriptsEnabled() {
-        return this.scriptsEnabled;
-    }
-
-    @Override
     public SymbolTable getPreviewSymbolTable() {
         return this.previewSymbolTable;
     }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.swing/org.gvsig.expressionevaluator.swing.impl/src/main/java/org/gvsig/expressionevaluator/swing/impl/DefaultJExpressionBuilderView2.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.swing/org.gvsig.expressionevaluator.swing.impl/src/main/java/org/gvsig/expressionevaluator/swing/impl/DefaultJExpressionBuilderView2.java	(revision 44532)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.swing/org.gvsig.expressionevaluator.swing.impl/src/main/java/org/gvsig/expressionevaluator/swing/impl/DefaultJExpressionBuilderView2.java	(revision 44533)
@@ -8,6 +8,7 @@
 import javax.swing.ImageIcon;
 import javax.swing.JButton;
 import javax.swing.JComboBox;
+import javax.swing.JComponent;
 import javax.swing.JLabel;
 import javax.swing.JList;
 import javax.swing.JPanel;
@@ -18,6 +19,8 @@
 import javax.swing.JTextField;
 import javax.swing.JTree;
 import javax.swing.border.EmptyBorder;
+import org.gvsig.configurableactions.ConfigurableActionsMamager;
+import org.gvsig.tools.util.ToolsUtilLocator;
 
 public class DefaultJExpressionBuilderView2 extends JPanel {
 
@@ -107,6 +110,7 @@
 
     }
 
+    JPanel pnlCfgActions = new JPanel();
     JTabbedPane tabExpressionBuilder = new JTabbedPane();
 
     JList lstSimpleElement = new JList();
@@ -141,10 +145,10 @@
     JTextField txtSimpleElementFilter = new JTextField();
     JButton btnSimpleElementFilter = new JButton();
     JPanel pnlDescription = new JPanel();
-    JPanel pnlScriptEditorContainer = new JPanel();
-    JComboBox cboPickerScripts = new JComboBox();
-    JButton btnPickerRemove = new JButton();
-    JButton btnPickerSelectScript = new JButton();
+//    JPanel pnlScriptEditorContainer = new JPanel();
+//    JComboBox cboPickerScripts = new JComboBox();
+//    JButton btnPickerRemove = new JButton();
+//    JButton btnPickerSelectScript = new JButton();
 
     JSplitPane spnlExpression = new JSplitPane(JSplitPane.VERTICAL_SPLIT);
     JSplitPane spnlBottom = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT);
@@ -272,20 +276,20 @@
         btnSimpleElementFilter.setName("btnSimpleElementFilter");
         btnSimpleElementFilter.setBorder(emptyborder2x2);
 
-        pnlScriptEditorContainer.setName("pnlScriptEditorContainer");
+//        pnlScriptEditorContainer.setName("pnlScriptEditorContainer");
+//
+//        cboPickerScripts.setName("cboPickerScripts");
+//
+//        btnPickerRemove.setActionCommand("+");
+//        btnPickerRemove.setName("btnPickerRemove");
+//        btnPickerRemove.setText("R");
+//        btnPickerRemove.setBorder(emptyborder2x2);
+//
+//        btnPickerSelectScript.setActionCommand("+");
+//        btnPickerSelectScript.setName("btnPickerSelectScript");
+//        btnPickerSelectScript.setText("S");
+//        btnPickerSelectScript.setBorder(emptyborder2x2);
 
-        cboPickerScripts.setName("cboPickerScripts");
-
-        btnPickerRemove.setActionCommand("+");
-        btnPickerRemove.setName("btnPickerRemove");
-        btnPickerRemove.setText("R");
-        btnPickerRemove.setBorder(emptyborder2x2);
-
-        btnPickerSelectScript.setActionCommand("+");
-        btnPickerSelectScript.setName("btnPickerSelectScript");
-        btnPickerSelectScript.setText("S");
-        btnPickerSelectScript.setBorder(emptyborder2x2);
-
         this.scrExpression = new JScrollPane();
         this.scrExpression.setViewportView(txtExpression);
         this.scrExpression.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
@@ -318,11 +322,13 @@
 
         this.tabExpressionBuilder.setName("tabExpressionBuilder");
         this.tabExpressionBuilder.addTab("_Expression", null, this.spnlExpression);
-        this.tabExpressionBuilder.addTab("_Scripts", null, this.pnlScriptEditorContainer);
+//        this.tabExpressionBuilder.addTab("_Scripts", null, this.pnlScriptEditorContainer);
         
         this.setLayout(new BorderLayout());
         this.add(tabExpressionBuilder, BorderLayout.CENTER);
-
+        
+        this.add(pnlCfgActions, BorderLayout.PAGE_START);
+        
     }
 
     private JPanel getPanelTop() {
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.swing/org.gvsig.expressionevaluator.swing.impl/src/main/java/org/gvsig/expressionevaluator/swing/impl/DefaultJExpressionBuilder.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.swing/org.gvsig.expressionevaluator.swing.impl/src/main/java/org/gvsig/expressionevaluator/swing/impl/DefaultJExpressionBuilder.java	(revision 44532)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.swing/org.gvsig.expressionevaluator.swing.impl/src/main/java/org/gvsig/expressionevaluator/swing/impl/DefaultJExpressionBuilder.java	(revision 44533)
@@ -48,6 +48,7 @@
 import org.apache.commons.io.FilenameUtils;
 import org.apache.commons.io.IOUtils;
 import org.apache.commons.lang3.StringUtils;
+import org.gvsig.configurableactions.ConfigurableActionsMamager;
 import org.gvsig.expressionevaluator.Expression;
 import org.gvsig.expressionevaluator.ExpressionEvaluatorLocator;
 import org.gvsig.expressionevaluator.ExpressionEvaluatorManager;
@@ -68,13 +69,12 @@
 import static org.gvsig.tools.swing.api.bookmarkshistory.ActionEventWithCurrentValue.ID_GETVALUE;
 import static org.gvsig.tools.swing.api.bookmarkshistory.ActionEventWithCurrentValue.ID_SETVALUE;
 import org.gvsig.tools.swing.api.bookmarkshistory.BookmarksController;
-import org.gvsig.tools.swing.api.bookmarkshistory.BookmarksController.BookmarkEvent;
 import org.gvsig.tools.swing.api.bookmarkshistory.HistoryController;
-import org.gvsig.tools.swing.api.bookmarkshistory.HistoryController.HistoryEvent;
 import org.gvsig.tools.swing.api.pickercontroller.PickerController;
 import org.gvsig.tools.swing.api.script.ScriptSwingManager;
 import org.gvsig.tools.swing.api.threadsafedialogs.ThreadSafeDialogsManager;
 import org.gvsig.tools.swing.icontheme.IconTheme;
+import org.gvsig.tools.util.ToolsUtilLocator;
 
 /**
  *
@@ -302,6 +302,11 @@
 
     @SuppressWarnings("Convert2Lambda")
     private void initComponents() {
+        ConfigurableActionsMamager cfgActionsManager = ToolsUtilLocator.getConfigurableActionsMamager();
+        JComponent c = cfgActionsManager.getConfigurableActionsComponent(CONFIGURABLE_PANEL_ID, this);
+        pnlCfgActions.setLayout(new BorderLayout(0,0));
+        pnlCfgActions.add(c, BorderLayout.LINE_END);
+        
         final ToolsSwingManager toolsSwingManager = ToolsSwingLocator.getToolsSwingManager();
         final IconTheme theme = ToolsSwingLocator.getIconThemeManager().getCurrent();
         final I18nManager i18n = ToolsLocator.getI18nManager();
@@ -605,17 +610,17 @@
                 doInsert(" - ");
             }
         });
-        ScriptSwingManager scriptSwingManager = ToolsSwingLocator.getScriptSwingManager();
-        this.scriptPicker = scriptSwingManager.createListScriptPickerController(
-                cboPickerScripts,
-                btnPickerRemove,
-                btnPickerSelectScript
-        );
-        this.scriptEditor = scriptSwingManager.createScriptEditor();
-        this.pnlScriptEditorContainer.setLayout(new BorderLayout());
-        this.pnlScriptEditorContainer.add(this.scriptEditor.asJComponent(), BorderLayout.CENTER);
-    
-        this.tabExpressionBuilder.setEnabledAt(0, this.builderConfig.getPreferences().getScriptsEnabled());
+//        ScriptSwingManager scriptSwingManager = ToolsSwingLocator.getScriptSwingManager();
+//        this.scriptPicker = scriptSwingManager.createListScriptPickerController(
+//                cboPickerScripts,
+//                btnPickerRemove,
+//                btnPickerSelectScript
+//        );
+//        this.scriptEditor = scriptSwingManager.createScriptEditor();
+//        this.pnlScriptEditorContainer.setLayout(new BorderLayout());
+//        this.pnlScriptEditorContainer.add(this.scriptEditor.asJComponent(), BorderLayout.CENTER);
+//    
+//        this.tabExpressionBuilder.setEnabledAt(0, this.builderConfig.getPreferences().getScriptsEnabled());
         
         ActionListener historyAndBookmarkListener = new ActionListener() {
             @Override
@@ -785,29 +790,29 @@
         }
         Expression expression = ExpressionEvaluatorLocator.getManager().createExpression();
         expression.setPhrase(phrase);
-        Script script = ToolsLocator.getScriptManager().createScript("UserScript", "", "python");
-        this.scriptEditor.fetch(script);
-        if( !StringUtils.isEmpty(script.getCode()) ) {
-            expression.setUserScript(script);
-        }
+//        Script script = ToolsLocator.getScriptManager().createScript("UserScript", "", "python");
+//        this.scriptEditor.fetch(script);
+//        if( !StringUtils.isEmpty(script.getCode()) ) {
+//            expression.setUserScript(script);
+//        }
         return expression;
     }
 
     @Override
     public void setExpression(Expression expression) {
-        if( expression==null ) {
+//        if( expression==null ) {
             this.txtExpression.setText("");
-            try { this.scriptEditor.set(null); } catch(Exception ex) {}
-            this.scriptPicker.set(null);
-        } else {
-            this.txtExpression.setText(expression.getPhrase());
-            if( expression.getUserScript()!=null ) {
-                this.scriptEditor.set(expression.getUserScript());
-            }
-            if( expression.getScripts()!=null ) {
-                this.scriptPicker.set(expression.getScripts().toList());
-            }
-        }
+//            try { this.scriptEditor.set(null); } catch(Exception ex) {}
+//            this.scriptPicker.set(null);
+//        } else {
+//            this.txtExpression.setText(expression.getPhrase());
+//            if( expression.getUserScript()!=null ) {
+//                this.scriptEditor.set(expression.getUserScript());
+//            }
+//            if( expression.getScripts()!=null ) {
+//                this.scriptPicker.set(expression.getScripts().toList());
+//            }
+//        }
     }
 
     @Override
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.swing/org.gvsig.expressionevaluator.swing.impl/src/main/java/org/gvsig/expressionevaluator/swing/impl/DefaultExpressionPickerController.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.swing/org.gvsig.expressionevaluator.swing.impl/src/main/java/org/gvsig/expressionevaluator/swing/impl/DefaultExpressionPickerController.java	(revision 44532)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.swing/org.gvsig.expressionevaluator.swing.impl/src/main/java/org/gvsig/expressionevaluator/swing/impl/DefaultExpressionPickerController.java	(revision 44533)
@@ -86,6 +86,9 @@
         this.config = new DefaultExpressionBuilderConfig(manager);
         this.text = text;
         this.button = button;
+        if(  "...".equals(this.button.getText()) ) {
+            this.button.setText("");
+        }
         this.value = null;
         this.returnNullWhenEmptyExpression = true;
         this.button.setIcon(this.getIcon("picker-expression"));
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/fmap/dal/impl/expressionevaluator/DefaultFeatureSymbolTable.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/fmap/dal/impl/expressionevaluator/DefaultFeatureSymbolTable.java	(revision 44532)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/fmap/dal/impl/expressionevaluator/DefaultFeatureSymbolTable.java	(revision 44533)
@@ -295,18 +295,18 @@
         this.addFunction(new ForeingValueFunction());
     }
 
-    @SuppressWarnings("OverridableMethodCallInConstructor")
-    public DefaultFeatureSymbolTable(Script userScript, UnmodifiableBasicList<Script> scripts) {
-        this();
-        if (userScript != null) {
-            this.getScripts().add(userScript);
-        }
-        if (scripts != null && !scripts.isEmpty()) {
-            for (Script script : scripts) {
-                this.getScripts().add(script);
-            }
-        }
-    }
+//    @SuppressWarnings("OverridableMethodCallInConstructor")
+//    public DefaultFeatureSymbolTable(Script userScript, UnmodifiableBasicList<Script> scripts) {
+//        this();
+//        if (userScript != null) {
+//            this.getScripts().add(userScript);
+//        }
+//        if (scripts != null && !scripts.isEmpty()) {
+//            for (Script script : scripts) {
+//                this.getScripts().add(script);
+//            }
+//        }
+//    }
 
     @Override
     public FeatureSymbolTable clone() throws CloneNotSupportedException {
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/fmap/dal/impl/expressionevaluator/DefaultExpressionEvaluator.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/fmap/dal/impl/expressionevaluator/DefaultExpressionEvaluator.java	(revision 44532)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/fmap/dal/impl/expressionevaluator/DefaultExpressionEvaluator.java	(revision 44533)
@@ -97,8 +97,8 @@
         this.expression = expression;
         this.symbolTable = manager.createSymbolTable();
         this.featureSymbolTable = new DefaultFeatureSymbolTable(
-                expression.getUserScript(), 
-                expression.getScripts()
+//                expression.getUserScript(), 
+//                expression.getScripts()
         );
         this.symbolTable.addSymbolTable(this.featureSymbolTable);
 
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/operations/CalculateEnvelopeOfColumnOperation.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/operations/CalculateEnvelopeOfColumnOperation.java	(revision 44532)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/operations/CalculateEnvelopeOfColumnOperation.java	(revision 44533)
@@ -141,7 +141,23 @@
         ResultSet rs = null;
         try {
             st = conn.createStatement();
-            rs = JDBCUtils.executeQuery(st, sql);
+            try {
+                rs = st.executeQuery(sql);
+                // No llamo al de JDBC utils para que no meta el error
+                // en el log.
+                // rs = JDBCUtils.executeQuery(st, sql);
+            } catch(SQLException ex) {
+//                Para calcular el envelope se esta lanzando una colsulta como:
+//                   SELECT ST_AsBinary(ST_Extent("geometry")) 
+//                   FROM "gis_osm_roads_free_1" 
+//                   WHERE ( ("geometry") IS NOT NULL )
+//                Que falla cuando no hay registros al recibir un NULL en el 
+//                ST_AsBinary. 
+//                A falta de una forma mejor de detectar eso, si peta en este
+//                punto asumiremos que no hay registros en la consulta y devolveremos
+//                null como envelope.
+                return null;
+            }
             if (!rs.next()) {
                 return null;
             }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.swing/org.gvsig.fmap.dal.swing.impl/src/main/java/org/gvsig/fmap/dal/swing/impl/DefaultDALSwingLibrary.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.swing/org.gvsig.fmap.dal.swing.impl/src/main/java/org/gvsig/fmap/dal/swing/impl/DefaultDALSwingLibrary.java	(revision 44532)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.swing/org.gvsig.fmap.dal.swing.impl/src/main/java/org/gvsig/fmap/dal/swing/impl/DefaultDALSwingLibrary.java	(revision 44533)
@@ -39,6 +39,7 @@
 import org.gvsig.fmap.dal.swing.impl.dataStoreParameters.DefaultDataStoreParametersPanelManager;
 import org.gvsig.fmap.dal.swing.impl.dynobjectutils.CreateComboModelFromTable;
 import org.gvsig.fmap.dal.swing.impl.expressionevaluator.FeatureStoreElementFactory;
+import org.gvsig.fmap.dal.swing.impl.jdbc.JDBCConnectionPickerController;
 import org.gvsig.fmap.dal.swing.impl.searchpanel.DefaultSearchPanel;
 import org.gvsig.tools.ToolsLocator;
 import org.gvsig.tools.dynobject.DynObjectManager;
@@ -85,6 +86,7 @@
             JDynFormFieldRelatedFeaturesFactory.selfRegister();
             
             DefaultSearchPanel.selfRegister();
+            JDBCConnectionPickerController.selfRegister();
             DefaultJFeaturesForm.selfRegister();
 
             DynObjectManager dynObjectmanager = ToolsLocator.getDynObjectManager();
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.swing/org.gvsig.fmap.dal.swing.impl/src/main/java/org/gvsig/fmap/dal/swing/impl/jdbc/JDBCConnectionPickerController.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.swing/org.gvsig.fmap.dal.swing.impl/src/main/java/org/gvsig/fmap/dal/swing/impl/jdbc/JDBCConnectionPickerController.java	(revision 44532)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.swing/org.gvsig.fmap.dal.swing.impl/src/main/java/org/gvsig/fmap/dal/swing/impl/jdbc/JDBCConnectionPickerController.java	(revision 44533)
@@ -4,6 +4,7 @@
 import java.awt.event.ActionListener;
 import java.awt.event.ItemEvent;
 import java.awt.event.ItemListener;
+import java.net.URL;
 import javax.swing.ComboBoxModel;
 import javax.swing.JButton;
 import javax.swing.JComboBox;
@@ -15,8 +16,10 @@
 import org.gvsig.fmap.dal.store.jdbc.JDBCServerExplorerParameters;
 import org.gvsig.fmap.dal.swing.DALSwingLocator;
 import org.gvsig.fmap.dal.swing.jdbc.JDBCConnectionDialog;
+import org.gvsig.tools.swing.api.ToolsSwingLocator;
 import org.gvsig.tools.swing.api.pickercontroller.AbstractPickerController;
 import org.gvsig.tools.swing.api.pickercontroller.PickerController;
+import org.gvsig.tools.swing.icontheme.IconTheme;
 import org.gvsig.tools.util.LabeledValue;
 import org.gvsig.tools.util.LabeledValueImpl;
 
@@ -43,6 +46,12 @@
                 doAddConnection();
             }
         });
+        if( "...".equals(this.btnConnection.getText()) ) {
+            this.btnConnection.setText("");
+        }
+        IconTheme theme = ToolsSwingLocator.getIconThemeManager().getCurrent();
+        this.btnConnection.setIcon(theme.get("database-connection-add"));
+        
         this.cboConnection.addItemListener(new ItemListener() {
             @Override
             public void itemStateChanged(ItemEvent e) {
@@ -127,4 +136,17 @@
         return this.cboConnection.isEnabled();
     }
     
+    public static void selfRegister() {
+        String[][] iconNames = new String[][]{
+            new String[]{"dalswing", "database-connection-add"}
+        };
+        IconTheme theme = ToolsSwingLocator.getIconThemeManager().getCurrent();
+        for (String[] icon : iconNames) {
+            URL url = JDBCConnectionPickerController.class.getResource(icon[1] + ".png");
+            theme.registerDefault("DALSwing", icon[0], icon[1], null, url);
+        }
+        
+    }
+    
+    
 }
